SettableBeanProperty.InnerClassProperty (Jackson JSON Processor)
Date: 2013-07-14

org.codehaus.jackson.map.deser

## Class SettableBeanProperty.InnerClassProperty

- java.lang.Object
- - org.codehaus.jackson.map.deser.SettableBeanProperty
  - - org.codehaus.jackson.map.deser.SettableBeanProperty.InnerClassProperty

- All Implemented Interfaces:
    BeanProperty, Named
  Enclosing class:
    SettableBeanProperty

      public static final class SettableBeanProperty.InnerClassProperty
      extends SettableBeanProperty

  This sub-class is used to handle special case of value being a non-static inner class. If so, we will have to use a special alternative for default constructor; but otherwise can delegate to regular implementation.
  Since:
    1.9

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.codehaus.jackson.map.deser.SettableBeanProperty

      `SettableBeanProperty.FieldProperty, SettableBeanProperty.InnerClassProperty, SettableBeanProperty.ManagedReferenceProperty, SettableBeanProperty.MethodProperty, SettableBeanProperty.NullProvider, SettableBeanProperty.SetterlessProperty`

    - ### Nested classes/interfaces inherited from interface org.codehaus.jackson.map.BeanProperty

      `BeanProperty.Std`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected Constructor<?>` | `_creator` Single-arg constructor we use for value instantiation.
    `protected SettableBeanProperty` | `_delegate` Actual property that we use after value construction.

    - ### Fields inherited from class org.codehaus.jackson.map.deser.SettableBeanProperty

      `_contextAnnotations, _managedReferenceName, _nullProvider, _propertyIndex, _propName, _type, _valueDeserializer, _valueTypeDeserializer`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `SettableBeanProperty.InnerClassProperty(SettableBeanProperty.InnerClassProperty src, JsonDeserializer<Object> deser)`
    `` | `SettableBeanProperty.InnerClassProperty(SettableBeanProperty delegate, Constructor<?> ctor)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `deserializeAndSet(JsonParser jp, DeserializationContext ctxt, Object bean)` Method called to deserialize appropriate value, given parser (and context), and set it using appropriate mechanism.
    `<A extends Annotation> A` | `getAnnotation(Class<A> acls)` Method for finding annotation associated with this property; meaning annotation associated with one of entities used to access property.
    `AnnotatedMember` | `getMember()` Method for accessing primary physical entity that represents the property; annotated field, method or constructor property.
    `void` | `set(Object instance, Object value)`
    `SettableBeanProperty.InnerClassProperty` | `withValueDeserializer(JsonDeserializer<Object> deser)`

    - ### Methods inherited from class org.codehaus.jackson.map.deser.SettableBeanProperty

      `_throwAsIOE, _throwAsIOE, assignIndex, deserialize, getContextAnnotation, getDeclaringClass, getInjectableValueId, getManagedReferenceName, getName, getPropertyIndex, getPropertyName, getProperytIndex, getType, getValueDeserializer, getValueTypeDeserializer, hasValueDeserializer, hasValueTypeDeserializer, setManagedReferenceName, setValueDeserializer, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### _delegate

          protected final SettableBeanProperty _delegate

      Actual property that we use after value construction.

    - #### _creator

          protected final Constructor<?> _creator

      Single-arg constructor we use for value instantiation.

  - ### Constructor Detail

    - #### SettableBeanProperty.InnerClassProperty

          public SettableBeanProperty.InnerClassProperty(SettableBeanProperty delegate,
                                                 Constructor<?> ctor)

    - #### SettableBeanProperty.InnerClassProperty

          protected SettableBeanProperty.InnerClassProperty(SettableBeanProperty.InnerClassProperty src,
                                                 JsonDeserializer<Object> deser)

  - ### Method Detail

    - #### withValueDeserializer

          public SettableBeanProperty.InnerClassProperty withValueDeserializer(JsonDeserializer<Object> deser)

      Specified by:
        `withValueDeserializer` in class `SettableBeanProperty`

    - #### getAnnotation

          public <A extends Annotation> A getAnnotation(Class<A> acls)

      Description copied from interface: `BeanProperty`
      Method for finding annotation associated with this property; meaning annotation associated with one of entities used to access property.
      Specified by:
        `getAnnotation` in interface `BeanProperty`
      Specified by:
        `getAnnotation` in class `SettableBeanProperty`

    - #### getMember

          public AnnotatedMember getMember()

      Description copied from interface: `BeanProperty`
      Method for accessing primary physical entity that represents the property; annotated field, method or constructor property.
      Specified by:
        `getMember` in interface `BeanProperty`
      Specified by:
        `getMember` in class `SettableBeanProperty`

    - #### deserializeAndSet

          public void deserializeAndSet(JsonParser jp,
                               DeserializationContext ctxt,
                               Object bean)
                                 throws IOException,
                                        JsonProcessingException

      Description copied from class: `SettableBeanProperty`
      Method called to deserialize appropriate value, given parser (and context), and set it using appropriate mechanism. Pre-condition is that passed parser must point to the first token that should be consumed to produce the value (the only value for scalars, multiple for Objects and Arrays).
      Specified by:
        `deserializeAndSet` in class `SettableBeanProperty`
      Throws:
        `IOException`
        `JsonProcessingException`

    - #### set

          public final void set(Object instance,
                 Object value)
                         throws IOException

      Specified by:
        `set` in class `SettableBeanProperty`
      Throws:
        `IOException`